Summary: The GNU core utilities: a set of tools commonly used in shell scripts
Name:    coreutils
Version: 6.10
Release: %mkrel 4
License: GPLv3+
Group:   System/Base
Url:     http://www.gnu.org/software/coreutils/

Source0: http://ftp.gnu.org/gnu/%name/%name-%version.tar.lzma
Source200:  su.pamd
Source201:  help2man

# fileutils
Patch101: coreutils-5.93-spacedir.patch
Patch1155: coreutils-6.9-force-option--override--interactive-option.patch
Patch118: fileutils-4.1-ls_h.patch
Patch152: coreutils-4.5.7-touch_errno.patch
Patch500: textutils-2.0.17-mem.patch

# sh-utils
Patch703: coreutils-5.93-dateman.patch
Patch704: sh-utils-1.16-paths.patch
# RMS will never accept the PAM patch because it removes his historical
# rant about Twenex and the wheel group, so we'll continue to maintain
# it here indefinitely.
Patch706: coreutils-6.10-pam.patch
Patch711: sh-utils-2.0.12-hname.patch

# (sb) lin18nux/lsb compliance - normally from here:
# http://www.openi18n.org/subgroups/utildev/patch/
# this one is actually a merger of 5.2 and 5.3, as join segfaults
# compiled with gcc4 and the 5.1/5.2 patch
Patch800: coreutils-6.10-new-i18n.patch
# small pt_BR fix
Patch801: coreutils-5.2.1-ptbrfix.patch

Patch904: coreutils-5.0.91-allow_old_options.patch
Patch909: coreutils-5.1.0-64bit-fixes.patch
Patch910: coreutils-6.10-uname.patch

# https://qa.mandriva.com/show_bug.cgi?id=38577
Patch911: coreutils-6.10-groupfix.patch

#(peroyvind): adds coloring for lzma compressed files just like for .gz etc.
#Patch1010: coreutils-6.9-lzma-ls-coloring.patch
Patch1011: coreutils-6.9-DIR_COLORS-mdkconf.patch
#(peroyvind): add back always red blinking on broken symlinks
Patch1013: coreutils-6.9-always-blinking-colors-on-broken-symlinks.patch

BuildRoot: %_tmppath/%{name}-root
BuildRequires:	gettext termcap-devel pam-devel
BuildRequires:  texinfo >= 4.3
BuildRequires:	automake
BuildRequires:	libacl-devel libattr-devel
Requires:   pam >= 0.66-12

Provides:	fileutils = %version, sh-utils = %version, stat, textutils = %version
Obsoletes:	fileutils sh-utils stat textutils

Conflicts:  tetex < 1.0.7-49mdk
Obsoletes:  base64

%description
These are the GNU core utilities.  This package is the union of
the old GNU fileutils, sh-utils, and textutils packages.

These tools are the GNU versions of common useful and popular
file & text utilities which are used for:
- file management
- shell scripts
- modifying text file (spliting, joining, comparing, modifying, ...)

Most of these programs have significant advantages over their Unix
counterparts, such as greater speed, additional options, and fewer
arbitrary limits.

The following tools are included:

  base64 basename cat chcon chgrp chmod chown chroot cksum comm cp csplit
  cut date dd df dir dircolors dirname du echo env expand expr factor
  false fmt fold groups head hostid id install join kill link ln logname
  ls md5sum mkdir mkfifo mknod mktemp mv nice nl nohup od paste pathchk
  pinky pr printenv printf ptx pwd readlink rm rmdir runcon seq sha1sum
  sha224sum sha256sum sha384sum sha512sum shred shuf sleep sort split
  stat stty su sum sync tac tail tee test touch tr true tsort tty uname
  unexpand uniq unlink users vdir wc who whoami yes

%package doc
Summary: Coreutils documentation in info format
Group: Books/Computer books
Requires: coreutils >= 4.5.4-2mdk
Requires(post,preun): info-install

%description doc
This package contains coreutils documentation in GNU info format.

%prep
%setup -q

# fileutils
%patch101 -p1 -b .space
%patch1155 -p0 -b .override
%patch118 -p1
%patch152 -p1

# textutils
%patch500 -p1

# sh-utils
%patch703 -p1 -b .dateman
%patch704 -p1 -b .paths
%patch706 -p1 -b .pam

# li18nux/lsb
%patch800 -p1 -b .i18n
%patch801 -p0 -b .ptbr

#%patch904 -p1 -b .old-options
%patch909 -p1 -b .64bit
%patch910 -p1 -b .cpu
%patch911 -p1 -b .groups

#%patch1010 -p1 -b .lzma_colors
%patch1011 -p1 -b .colors_mdkconf
%patch1013 -p1 -b .broken_blink

cp %SOURCE201 man/help2man
chmod +x man/help2man
chmod +w ./src/dircolors.h
./src/dcgen ./src/dircolors.hin > ./src/dircolors.h

%build
export DEFAULT_POSIX2_VERSION=199209
aclocal -I m4
automake --gnits --add-missing
autoconf
CFLAGS="$RPM_OPT_FLAGS -D_GNU_SOURCE=1" %configure2_5x --enable-largefile --enable-pam
%make HELP2MAN=$PWD/man/help2man

# XXX docs should say /var/run/[uw]tmp not /etc/[uw]tmp
perl -pi -e 's,/etc/utmp,/var/run/utmp,g;s,/etc/wtmp,/var/run/wtmp,g' doc/coreutils.texi

%check
chmod a+x tests/sort/sort-mb-tests
# Run the test suite:
%make check

%install
[[ -f ChangeLog ]] && bzip2 -9f ChangeLog
# for help2man:
export PATH=$PATH:RPM_BUILD_ROOT/man

rm -rf $RPM_BUILD_ROOT
%makeinstall_std

# man pages are not installed with make install
make mandir=$RPM_BUILD_ROOT%{_mandir} install-man

# fix japanese catalog file
if [ -d $RPM_BUILD_ROOT/%{_datadir}/locale/ja_JP.EUC/LC_MESSAGES ]; then
   mkdir -p $RPM_BUILD_ROOT/%{_datadir}/locale/ja/LC_MESSAGES
   mv $RPM_BUILD_ROOT/%{_datadir}/locale/ja_JP.EUC/LC_MESSAGES/*mo \
		$RPM_BUILD_ROOT/%{_datadir}/locale/ja/LC_MESSAGES
   rm -rf $RPM_BUILD_ROOT/%{_datadir}/locale/ja_JP.EUC
fi

# let be compatible with old fileutils, sh-utils and textutils packages :
mkdir -p $RPM_BUILD_ROOT{/bin,%_bindir,%_sbindir,%_sysconfdir/pam.d}
for f in basename cat chgrp chmod chown cp cut date dd df echo env expr false id link ln ls mkdir mknod mv nice pwd rm rmdir sleep sort stat stty sync touch true uname unlink
do
	mv $RPM_BUILD_ROOT/{%_bindir,bin}/$f 
done

ln -sf ../../bin/expr $RPM_BUILD_ROOT%_bindir/

# chroot was in /usr/sbin :
mv $RPM_BUILD_ROOT/{%_bindir,%_sbindir}/chroot
# {cat,sort,cut} were previously moved from bin to /usr/bin and linked into 
for i in env cut; do ln -sf ../../bin/$i $RPM_BUILD_ROOT/usr/bin; done

install -m644 src/dircolors.hin -D %{buildroot}%{_sysconfdir}/DIR_COLORS

# su
install -m 4755 src/su $RPM_BUILD_ROOT/bin

# These come from util-linux and/or procps.
for i in hostname uptime ; do
	rm -f $RPM_BUILD_ROOT{%_bindir/$i,%_mandir/man1/${i}.1}
done

install -m 644 %SOURCE200 $RPM_BUILD_ROOT%_sysconfdir/pam.d/su

bzip2 -9f old/*/C* || :

# fix conflict with util-linux:
rm -f $RPM_BUILD_ROOT%_mandir/man1/kill.1

#TV# find_lang look for LC_MESSAGES, not LC_TIME:
#TV(cd $RPM_BUILD_ROOT; find .%_datadir/locale/ -name coreutils.mo | fgrep LC_TIME | \
#TV	sed -e "s!^.*/share/locale/\([^/]*\)/!%lang(\1) %_datadir/locale/\1/!") >> %name.lang
find $RPM_BUILD_ROOT%_datadir/locale/ -name coreutils.mo | fgrep LC_TIME | xargs rm -f

%find_lang %name

# (sb) Deal with Installed (but unpackaged) file(s) found
rm -f $RPM_BUILD_ROOT%{_datadir}/info/dir

%clean
rm -rf $RPM_BUILD_ROOT

%pre doc
# We must desinstall theses info files since they're merged in
# coreutils.info. else their postun'll be runned too last
# and install-info'll faill badly because of doubles
for file in sh-utils.info textutils.info fileutils.info; do
	if [ -f /usr/share/info/$file.bz2 ]; then
		/sbin/install-info /usr/share/info/$file.bz2 --dir=/usr/share/info/dir --remove &> /dev/null
	fi
done

%preun doc
%_remove_install_info %name.info

%post doc
%_install_info %name.info
# The next true is needed: else, if there's a problem, the 
# package'll be installed 2 times because of trigger faillure
true

%files -f %{name}.lang
%defattr(-,root,root)
%config(noreplace) %{_sysconfdir}/D*
%config(noreplace) %{_sysconfdir}/pam.d/su
%doc README
/bin/*
%_bindir/*
%_sbindir/chroot

%files doc
%defattr(-,root,root)
%doc ABOUT-NLS ChangeLog.bz2 NEWS THANKS TODO old/*
%_infodir/coreutils*
%_mandir/man*/*


%changelog
* Fri Mar 07 2008 Andreas Hasenack <andreas@mandriva.com> 6.10-4mdv2008.1
+ Revision: 181646
- drop specific versioned requires of automake
- fix "id" can't fetch group name (#38577)

* Tue Jan 29 2008 Funda Wang <fundawang@mandriva.org> 6.10-3mdv2008.1
+ Revision: 159680
- fix requirment on info-install

* Sun Jan 27 2008 Funda Wang <fundawang@mandriva.org> 6.10-2mdv2008.1
+ Revision: 158552
- update binary list

* Sat Jan 26 2008 Funda Wang <fundawang@mandriva.org> 6.10-1mdv2008.1
+ Revision: 158248
- Update i18n patch with fedora one
- rediff uname patch
- rediff pam patch
- New version 6.10
- drop patches merged upstream

* Fri Jan 11 2008 Thierry Vignaud <tvignaud@mandriva.com> 6.9-6mdv2008.1
+ Revision: 149129
- rebuild
- kill re-definition of %%buildroot on Pixel's request

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

  + Arnaud Patard <apatard@mandriva.com>
    - Use proper way to change CFLAGS in the spec file.
      (aka dd if=/dev/zero bs=1M count=300 | time -p sum -s bug fix).

* Thu Sep 06 2007 Per Øyvind Karlsen <pkarlsen@mandriva.com> 6.9-5mdv2008.0
+ Revision: 81114
- disable coloring for text documents

* Sun Aug 26 2007 Per Øyvind Karlsen <pkarlsen@mandriva.com> 6.9-4mdv2008.0
+ Revision: 71568
- give black background for white text for documents in case of using
  terminal with white background (updates P1011, fixes #32827)
- add some more files to doc coloring (updates P1011)

* Thu Aug 23 2007 Thierry Vignaud <tvignaud@mandriva.com> 6.9-3mdv2008.0
+ Revision: 69360
- kill file require on info-install

  + Per Øyvind Karlsen <pkarlsen@mandriva.com>
    - add coloring for .wma & *rc (updates P1011)
    - add even more formats (updates P1011, I have no life:p)
    - drop lzma patch (P1010) and rather merge with generic dircolors patch (P1011)
    - add some more formats (updates P1011)
    - regenerate dircolors.h with dcgen in stead of patch
    - add coloring for backup files (updates P1011)
    - drop junk and be sure not to remove copyright notice in dircolors.hin (updates P1011)
    - add white color for document formats (updates P1011)
    - add a few more formats (updates P1011)
    - update P1011 with coloring for .flv (flash video)

* Sat Jul 14 2007 Funda Wang <fundawang@mandriva.org> 6.9-2mdv2008.0
+ Revision: 51981
- Add fedora patch to build against glibc 2.6
- Update program list
- Obsoletes base64

  + Per Øyvind Karlsen <pkarlsen@mandriva.com>
    - add back always blinking colors for broken symlinks (P1013)
    - fix P1011 as it reverted P1010 and lzma coloring

* Thu Jul 12 2007 Funda Wang <fundawang@mandriva.org> 6.9-1mdv2008.0
+ Revision: 51465
- Enable test scripts
- Remove old acl patches
- rediff patch 1011
- Rediff patch 1010.
- Add patch1012: From fedora, fix ls -x
- Rediff patch800: from fedora
- Rediff patch706: from Fedora.
- Rediff patch1155
- remove patch107: obsoletes by upstream code
- Remove patch102: sparc detection not there
- Remove patch0: lg.po not there
- New upstream version

* Wed Jul 11 2007 Per Øyvind Karlsen <pkarlsen@mandriva.com> 5.97-8mdv2008.0
+ Revision: 51341
- drop S101 & S102 and rather merge with dircolors.hin in package as well as add few types (P1011)
- add lzma coloring support for ls (P1010, might need some more work?)
- change to and fix usage of new automake 1.10
- fix inclusion of locale files

* Mon May 28 2007 Ademar de Souza Reis Jr <ademar@mandriva.com.br> 5.97-6mdv2008.0
+ Revision: 32036
- fix -doc description
- remove redundant build-requirement of acl-devel

  + Anssi Hannula <anssi@mandriva.org>
    - fix URL


* Tue Feb 20 2007 Thierry Vignaud <tvignaud@mandriva.com> 5.97-6mdv2007.0
+ Revision: 123126
- bump release (#28834)

  + Per Øyvind Karlsen <pkarlsen@mandriva.com>
    - reintroduce interactive override (-if) and rather fix check (P1155, real fix for #16209)

  + Olivier Blin <oblin@mandriva.com>
    - explicitely run autotools (or else configure is run two times), we need them for pam/i18n/acl/xattr/hname

* Fri Oct 20 2006 Olivier Blin <oblin@mandriva.com> 5.97-4mdv2007.1
+ Revision: 71290
- rebuild for su to be linked with pam (#26353 and #26527)
- Import coreutils

* Thu Aug 31 2006 Thierry Vignaud <tvignaud@mandriva.com> 5.97-3mdv2007.0
- kill patch 1155 thus the testsuite works again (#16209)
  [warning: this means cp -i -f behaves like cp -i, no more like cp -f]
- update & reenable patch 1001-1004 from suse (ACL+xattr support)

* Thu Aug 31 2006 Thierry Vignaud <tvignaud@mandriva.com> 5.97-1mdv2007.0
- new release
- update patches 800 & 1001 from rh
- rediff patches 101, 105, 111, 114, 1115, 703 & 1003
- kill patches 108, 112, 116, 117, 153, 908, 2000 (merged upstream)
- kill patch 2001 (no more needed)
- kill patch 105 (unstandard option)
- drop patches 111 (deprecated rh patch introduced in fileutils-4.1.1-1mdk),
  114 (likewise, 4.1) 115 (likewise, 4.1.5-1mdk), 710, 901 (no more needed),
  1002 (merged in 1001)
- source 200: sync with fedora
- disable patch 104 (it's time to catch offenders) and 1003 (broken)
- fix build

* Thu Aug 31 2006 Thierry Vignaud <tvignaud@mandriva.com> 5.2.1-11mdv2007.0
- patch 2000: update zh translation (#17302)
- patch 2001: fix build
- fix macro-in-%%changelog

* Sat May 13 2006 Stefan van der Eijk <stefan@eijk.nu> 5.2.1-10mdk
- rebuild for sparc

* Mon Jan 30 2006 Olivier Blin <oblin@mandriva.com> 5.2.1-9mdk
- use "include" directive instead of deprecated pam_stack module

* Fri Aug 19 2005 Stew Benedict <sbenedict@mandriva.com> 5.2.1-8mdk
- redo LSB/i18n patch, join segfaults during LSB testing 
  when compiled with gcc4

* Fri Aug 12 2005 Leonardo Chiquitto Filho <chiquitto@mandriva.com> 5.2.1-7mdk
- patches 1001, 1002 1003: add support to posix acls and extended attributes
  (#15050)
- patch 801: fix some typos in pt_BR.po file

* Fri Aug 12 2005 Nicolas Lcureuil <neoclust@mandriva.org> 5.2.1-6mdk
- fix rpmlint errors (PreReq)

* Thu Feb 10 2005 Thierry Vignaud <tvignaud@mandrakesoft.com> 5.2.1-5mdk
- move expr into /bin (#7052)

* Mon Jul 26 2004 Christiaan Welvaart <cjw@daneel.dyndns.org> 5.2.1-4mdk
- run automake for patch 111

* Fri Jun 25 2004 Thierry Vignaud <tvignaud@mandrakesoft.com> 5.2.1-3mdk
- simplify build

* Thu Jun 24 2004 Thierry Vignaud <tvignaud@mandrakesoft.com> 5.2.1-2mdk
- fix link with pam
- fix --short-circuit when %%build failled
- patch 910: show correct CPU name (Marcin Gondek, #7865)
  (if it brokes anything, we'll revert)
- patch 111: fix ls build

* Fri Apr 02 2004 Thierry Vignaud <tvignaud@mandrakesoft.com> 5.2.1-1mdk
- new release
- remove patch 502, 906 (useless)

